wftotem = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "CandyBar-2.0","AceDB-2.0" )
wftotem:RegisterDB("wftotemDB","wftotemDBPC");
wftotem:RegisterDefaults("profile", {
x=0,
y=40,
scale=0.7
} )

local wftot=0;
local airtotems={
["Grace of Air"]=1,
["Nature Resistance"]=1,
["Sentry"]=1,
["Grounding"]=1,
["Windwall"]=1,
["Tranquil Air"]=1,
["Wrath of Air"]=1
};
local xres, yres = 0,0;
local options = {};

function wftotem:OnEnable()
	wftotem:WFtotemSET();
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF");
--	self:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH");
	wftotem:getscreenres();
	wftotem:setoptions();
	wftotem:RegisterChatCommand("/wftotem", "/WFtotem", options);
end

function wftotem:CHAT_MSG_SPELL_SELF_BUFF()
	local mestart, meend, mecast = string.find(arg1, "You cast (.+) Totem\.");
	if (mecast) then
		if (mecast=="Windfury") then
			local down, up, lag = GetNetStats();
			wftotem:StopCandyBar("WFtotemBAR");
			wftotem:StartCandyBar("WFtotemBAR");
			wftot=GetTime();
--			DEFAULT_CHAT_FRAME:AddMessage("Cast WF!!!");
			wftotem:ScheduleEvent(self.rebuff,2*lag/1000,self);
		else
			if (airtotems[mecast]) then
				wftot=0;
				wftotem:StopCandyBar("WFtotemBAR");
				wftotem:StopCandyBar("WFtotrebuffBAR");
				DEFAULT_CHAT_FRAME:AddMessage("WF Destroyed!!!");
			end
		end
	end
	local mestart, meend, mecast = string.find(arg1, "You gain (.+) from Totemic Call\.");
	if (mecast) then
		wftot=0;
		wftotem:StopCandyBar("WFtotemBAR");
		wftotem:StopCandyBar("WFtotrebuffBAR");
--		DEFAULT_CHAT_FRAME:AddMessage("WF Destroyed!!!");
	end
end

function wftotem:rebuff()
	local reg, t, e, r = wftotem:CandyBarStatus("WFtotemBAR");
	if (r) then
	local down, up, lag = GetNetStats();
	wftotem:StopCandyBar("WFtotrebuffBAR");
	wftotem:StopCandyBar("WFtotfadeBAR");
	wftotem:ScheduleEvent(self.rebuff,5,self);
	wftotem:StartCandyBar("WFtotrebuffBAR");
	wftotem:StartCandyBar("WFtotfadeBAR");
--	DEFAULT_CHAT_FRAME:AddMessage("test");
	end
end

function wftotem:WFtotemSET()
	wftotem:RegisterCandyBarGroup("WFtotcandy");
	wftotem:SetCandyBarGroupPoint("WFtotcandy", "CENTER", "UIParent", "CENTER",wftotem.db.profile.x,wftotem.db.profile.y);
	wftotem:RegisterCandyBar("WFtotrebuffBAR",5,"Rebuff");
--	wftotem:SetCandyBarCompletion("WFtotrebuffBAR",function() wftotem:rebuff() end);
	wftotem:SetCandyBarColor("WFtotrebuffBAR","green",0.5);
	wftotem:SetCandyBarScale("WFtotrebuffBAR", wftotem.db.profile.scale);
	wftotem:RegisterCandyBarWithGroup("WFtotrebuffBAR","WFtotcandy");
	wftotem:RegisterCandyBar("WFtotfadeBAR",10,"Fade");
	wftotem:SetCandyBarColor("WFtotfadeBAR","green",0.5);
	wftotem:SetCandyBarScale("WFtotfadeBAR", wftotem.db.profile.scale);
	wftotem:RegisterCandyBarWithGroup("WFtotfadeBAR","WFtotcandy");
	wftotem:RegisterCandyBar("WFtotemBAR",120,"Totem");
	wftotem:SetCandyBarColor("WFtotemBAR","green",0.5);
	wftotem:SetCandyBarScale("WFtotemBAR", wftotem.db.profile.scale);
	wftotem:RegisterCandyBarWithGroup("WFtotemBAR","WFtotcandy");
end

function wftotem:getscreenres()
	local xyres=GetCVar("gxResolution");
	xres, yres=strsplit("x",xyres);
	xres=tonumber(xres);
	yres=tonumber(yres);
	-- DEFAULT_CHAT_FRAME:AddMessage(xres.." "..yres);
end

function wftotem:setoptions()
	options = { 
	    type='group',
	    args = {
	        x = {
	            type = 'range',
	            name = 'x',
	            desc = 'Change X coord of WFtotem timer',
	            min = (-1)*xres/2,
				max = xres/2,
				step = 1,
				get = "GetX",
	            set = "SetX",
	        },
			y = {
	            type = 'range',
	            name = 'y',
	            desc = 'Change Y coord of WFtotem timer',
	            min = (-1)*yres/2,
				max = yres/2,
				step = 1,
				get = "GetY",
	            set = "SetY",
	        },
			wfscale = {
	            type = 'range',
	            name = 'scale',
	            desc = 'Change Scale of WFtotem timer',
	            min = 0.3,
				max = 3,
				step = 0.1,
				get = "GetScale",
	            set = "SetScale",
	        }
	    }
	}
end

function wftotem:GetX()
    return wftotem.db.profile.x
end

function wftotem:SetX(newValue)
	wftotem.db.profile.x = newValue;
	wftotem:SetCandyBarGroupPoint("WFtotcandy", "CENTER", "UIParent", "CENTER",wftotem.db.profile.x,wftotem.db.profile.y);
	wftotem:StopCandyBar("WFtotfadeBAR");
	wftotem:StartCandyBar("WFtotfadeBAR");
end

function wftotem:GetY()
    return wftotem.db.profile.y
end

function wftotem:SetY(newValue)
	wftotem.db.profile.y = newValue;
	wftotem:SetCandyBarGroupPoint("WFtotcandy", "CENTER", "UIParent", "CENTER",wftotem.db.profile.x,wftotem.db.profile.y);
	wftotem:StopCandyBar("WFtotfadeBAR");
	wftotem:StartCandyBar("WFtotfadeBAR");
end

function wftotem:GetScale()
    return wftotem.db.profile.scale
end

function wftotem:SetScale(newValue)
	wftotem.db.profile.scale = newValue;
	wftotem:SetCandyBarScale("WFtotrebuffBAR", wftotem.db.profile.scale);
	wftotem:SetCandyBarScale("WFtotfadeBAR", wftotem.db.profile.scale);
	wftotem:SetCandyBarScale("WFtotemBAR", wftotem.db.profile.scale);
	wftotem:StopCandyBar("WFtotfadeBAR");
	wftotem:StartCandyBar("WFtotfadeBAR");
end